#!/bin/bash

# SETUP

NS_SF0=ns_sf0
NS_SF1=ns_sf1

IF_SF0=ens1f0
IF_SF1=ens1f1

IP_SF0=10.230.61.170
IP_SF1=10.230.61.171

ip netns add $NS_SF0
ip netns add $NS_SF1

ip link set $IF_SF0 netns $NS_SF0
ip link set $IF_SF1 netns $NS_SF1

ip netns exec $NS_SF0 ip link set $IF_SF0 up
ip netns exec $NS_SF1 ip link set $IF_SF1 up

ip netns exec $NS_SF0 ip addr add $IP_SF0/24 dev $IF_SF0
ip netns exec $NS_SF1 ip addr add $IP_SF1/24 dev $IF_SF1


# TEST SERVER ON SF0
ip netns exec $NS_SF0 netserver -L $IP_SF0

# TEST LOOP

# ROTATE MTU ON RX/TX SIDES
while true; do
for MTU_SF0 in 1500 9000; do

  ip netns exec $NS_SF0 ip link set $IF_SF0 down
  ip netns exec $NS_SF0 ip link set $IF_SF0 mtu $MTU_SF0
  ip netns exec $NS_SF0 ip link set $IF_SF0 up

  for MTU_SF1 in 1500 9000; do

    ip netns exec $NS_SF1 ip link set $IF_SF1 down
    ip netns exec $NS_SF1 ip link set $IF_SF1 mtu $MTU_SF1
    ip netns exec $NS_SF1 ip link set $IF_SF1 up

    for TEST in TCP_STREAM UDP_STREAM TCP_RR UDP_RR TCP_CRR; do
      echo test $TEST - MTU0: $MTU_SF0 - MTU1: $MTU_SF1
      date

      # TEST CLIENT ON SF1
      ip netns exec $NS_SF1 netperf -L $IP_SF1 -H $IP_SF0 -l 720 -t $TEST
      echo
    done
  done
done
done
